
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
! Header files with short name definitions
#include "function_FunctionPort_fAbbrev.h"
#include "randomgen_RandomGeneratorPort_fAbbrev.h"
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)

  ! DO-NOT-DELETE splicer.begin(integrators.Simpson._ctor)
  ! Insert the implementation here...

  ! Access private data
  type(integrators_Simpson_wrap) :: dp
  ! Allocate memory and initialize
  allocate(dp%d_private_data)
  call set_null(dp%d_private_data%frameworkServices)
  call integrators_Simpson__set_data_m(self, dp)

  ! DO-NOT-DELETE splicer.end(integrators.Simpson._ctor)


  ! DO-NOT-DELETE splicer.begin(integrators.Simpson._dtor)
  ! Insert the implementation here...

  ! Access private data and deallocate storage
  type(integrators_Simpson_wrap) :: dp
  call integrators_Simpson__get_data_m(self, dp)

  ! Decrement reference count for framework services handle
  if (not_null(dp%d_private_data%frameworkServices)) then
     call deleteRef(dp%d_private_data%frameworkServices)
  end if

  deallocate(dp%d_private_data)

  ! DO-NOT-DELETE splicer.end(integrators.Simpson._dtor)


  ! DO-NOT-DELETE splicer.begin(integrators.Simpson.integrate.use)
  ! Insert use statements here...
  use integrator_IntegratorPort
  use function_FunctionPort
  use randomgen_RandomGeneratorPort
  use gov_cca_Services
  use gov_cca_Port
  use sidl_BaseInterface
  use montecarlointegrator
  ! DO-NOT-DELETE splicer.end(integrators.Simpson.integrate.use)

  ! DO-NOT-DELETE splicer.begin(integrators.Simpson.integrate)
  ! Insert the implementation here...

  logical :: proceed

  type(gov_cca_Port_t) :: baseFunctionPort
  type(function_FunctionPort_t) :: myFunctionPort
  type(SIDL_BaseInterface_t) :: excptFunctionPort
  type(gov_cca_Port_t) :: baseRandomGeneratorPort
  type(randomgen_RandomGeneratorPort_t) :: myRandomGeneratorPort
  type(SIDL_BaseInterface_t) :: excptRandomGeneratorPort
  type(SIDL_BaseInterface_t) :: excpt

  ! Private data reference
  type(integrators_Simpson_wrap) :: dp

  ! Access private data
  call integrators_Simpson__get_data_m(self, dp)

  proceed = .true.
  if (is_null(dp%d_private_data%frameworkServices)) then
    proceed = .false.
  end if

  ! Obtain handles to uses ports

  if (proceed) then
     call getPort(dp%d_private_data%frameworkServices, &
          "FunctionPort", baseFunctionPort, excptFunctionPort)
    if (is_null(excptFunctionPort)) then
      call cast(baseFunctionPort, myFunctionPort)
      if (is_null(myFunctionPort)) then
        print *, "integrators.Simpson Exception: incompatible FunctionPort"
        proceed = .false.
      end if
    else
      print *, "integrators.Simpson Exception: in call getPort('FunctionPort')"
      proceed = .false.
    end if
  end if

  if (proceed) then
     call getPort(dp%d_private_data%frameworkServices, &
          "RandomGeneratorPort", baseRandomGeneratorPort, excptRandomGeneratorPort)
    if (is_null(excptRandomGeneratorPort)) then
      call cast(baseRandomGeneratorPort, myRandomGeneratorPort)
      if (is_null(myRandomGeneratorPort)) then
        print *, "integrators.Simpson Exception: incompatible RandomGeneratorPort"
        proceed = .false.
      end if
    else
      print *, "integrators.Simpson Exception: in call getPort('RandomGeneratorPort')"
      proceed = .false.
    end if
  end if

  !
  ! Make call to legacy procedure
  !
  ! WARNING, call (and procedure) will have to change if there are uses ports
  !          The uses ports should be passed to the procedure and called there
  !          at the appropriate point
  !

  retval = integrate_simp(lowbound, upbound, count)

  !
  ! Cleanup (delete dangling references and release ports)
  !

  if (is_null(excptFunctionPort)) then
    call deleteRef(baseFunctionPort)
  end if
  if (not_null(myFunctionPort)) then
    call releasePort(dp%d_private_data%frameworkServices, &
         "FunctionPort", excpt)
    if (not_null(excpt)) then
      print *, "integrators.Simpson Exception: in call releasePort('FunctionPort')"
      call deleteRef(excpt)
    end if
  end if

  if (is_null(excptRandomGeneratorPort)) then
    call deleteRef(baseRandomGeneratorPort)
  end if
  if (not_null(myRandomGeneratorPort)) then
    call releasePort(dp%d_private_data%frameworkServices, &
         "RandomGeneratorPort", excpt)
    if (not_null(excpt)) then
      print *, "integrators.Simpson Exception: in call releasePort('RandomGeneratorPort')"
      call deleteRef(excpt)
    end if
  end if
  ! DO-NOT-DELETE splicer.end(integrators.Simpson.integrate)


  ! DO-NOT-DELETE splicer.begin(integrators.Simpson.setServices.use)
  ! Insert use statements here...
  use gov_cca_TypeMap
  use gov_cca_Port
  ! DO-NOT-DELETE splicer.end(integrators.Simpson.setServices.use)

  ! DO-NOT-DELETE splicer.begin(integrators.Simpson.setServices)
  ! Insert the implementation here...

  character(len=*), parameter :: pn_IntegratorPort = 'IntegratorPort'
  character(len=*), parameter :: pt_IntegratorPort = 'integrator.IntegratorPort'
  character(len=*), parameter :: un_FunctionPort = 'FunctionPort'
  character(len=*), parameter :: ut_FunctionPort = 'function.FunctionPort'
  character(len=*), parameter :: un_RandomGeneratorPort = 'RandomGeneratorPort'
  character(len=*), parameter :: ut_RandomGeneratorPort = 'randomgen.RandomGeneratorPort'

  type(gov_cca_TypeMap_t)     :: myTypeMap
  type(SIDL_BaseInterface_t)  :: excpt
  type(gov_cca_Port_t)        :: myPort

  ! Access private data
  type(integrators_Simpson_wrap) :: dp
  call integrators_Simpson__get_data_m(self, dp)

  ! Set my reference to the services handle
  dp%d_private_data%frameworkServices = services
  ! Increment reference count for the services subroutine parameter
  call addRef(services)

  ! Create a TypeMap with my properties
  call createTypeMap(services, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "integrators.Simpson Exception: in setServices call createTypeMap()"
    call deleteRef(excpt)
  end if
  call cast(self, myPort)

  !
  ! Add the provided ports
  !

  call addProvidesPort(services, myPort, pn_IntegratorPort, &
                       pt_IntegratorPort, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "integrators.Simpson Exception: in setServices call addProvidesPort('IntegratorPort')"
    call deleteRef(excpt)
  end if

  !
  ! Register the used ports
  !

  call registerUsesPort(services, un_FunctionPort, &
                        ut_FunctionPort, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "integrators.Simpson Exception: in setServices call registerUsesPort('FunctionPort')"
    call deleteRef(excpt)
  end if

  call registerUsesPort(services, un_RandomGeneratorPort, &
                        ut_RandomGeneratorPort, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "integrators.Simpson Exception: in setServices call registerUsesPort('RandomGeneratorPort')"
    call deleteRef(excpt)
  end if


  call deleteRef(myTypeMap)

  ! DO-NOT-DELETE splicer.end(integrators.Simpson.setServices)


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
