module MidpointIntegrator

  interface integrate
    module procedure integrate_mp
  end interface integrate

contains

function integrate_mp(lowBound, upBound, count)
  use LinearFunction, only: evaluate
  implicit none
  real(kind(1.0D0)) :: integrate_mp
  real(kind(1.0D0)), intent(in) :: lowBound, upBound
  integer, intent(in) :: count

  ! LOCAL VARIABLES:

  integer :: i
  real(kind(1.0D0)) :: h, sum, x

  integrate_mp = 0.0D0
  sum = 0.0D0
  h = (upBound - lowBound) / count
           
  ! Compute integral

  do i = 0, count 
    x = lowBound + h * (i + 0.5)
    sum = sum + evaluate(x)
  end do
        
  integrate_mp = h * sum

end function integrate_mp

end module MidpointIntegrator
