module SimpsonIntegrator

  interface integrate
    module procedure integrate_simp
  end interface integrate

contains

function integrate_simp(lowBound, upBound, count)
  use LinearFunction, only: evaluate
  implicit none
  real(kind(1.0D0)) :: integrate_simp
  real(kind(1.0D0)), intent(in) :: lowBound, upBound
  integer, intent(in) :: count

  ! LOCAL VARIABLES:

  integer :: i, j, multiplier(3) = (/1,4,1/)
  real(kind(1.0D0)) :: h, x, sum = 0.0D0

  integrate_simp = 0.0D0
  h = (upBound - lowBound) / count / 2.0D0
           
  ! Compute integral

  do i = 0, count - 1
    do j = 0, 2
       x =  lowBound +  (2*i + j) * h
       sum = sum + multiplier(j+1) * evaluate(x)
    end do
  end do

  integrate_simp = h/3.0D0 * sum

end function integrate_simp

end module SimpsonIntegrator
