module TrapezoidIntegrator

  interface integrate
    module procedure integrate_trap
  end interface integrate

contains

function integrate_trap(lowBound, upBound, count)
  use LinearFunction, only: evaluate
  implicit none
  real(kind(1.0D0)) :: integrate_trap
  real(kind(1.0D0)), intent(in) :: lowBound, upBound
  integer, intent(in) :: count

  ! LOCAL VARIABLES:

  integer :: i
  real(kind(1.0D0)) :: h, sum

  integrate_trap = 0.0D0
  sum = 0.0D0
  h = (upBound - lowBound) / count
           
  ! Compute integral

  do i = 1, count 
    sum = sum + evaluate(lowBound + (i - 1) * h) &
              + evaluate(lowBound + i * h)
  end do
        
  integrate_trap = h/2.0D0 * sum

end function integrate_trap

end module TrapezoidIntegrator
